--- old/usr/src/uts/common/io/fibre-channel/fca/qlc/ql_init.c	Mon Aug  5 17:28:42 2019
+++ new/usr/src/uts/common/io/fibre-channel/fca/qlc/ql_init.c	Mon Aug  5 17:28:42 2019
@@ -19,13 +19,13 @@
  * CDDL HEADER END
  */
 
-/* Copyright 2010 QLogic Corporation */
+/* Copyright 2015 QLogic Corporation */
 
 /*
- * Copyright (c) 2008, 2010, Oracle and/or its affiliates. All rights reserved.
+ * Copyright (c) 2008, 2011, Oracle and/or its affiliates. All rights reserved.
  */
 
-#pragma ident	"Copyright 2010 QLogic Corporation; ql_init.c"
+#pragma ident	"Copyright 2015 QLogic Corporation; ql_init.c"
 
 /*
  * ISP2xxx Solaris Fibre Channel Adapter (FCA) driver source file.
@@ -33,7 +33,7 @@
  * ***********************************************************************
  * *									**
  * *				NOTICE					**
- * *		COPYRIGHT (C) 1996-2010 QLOGIC CORPORATION		**
+ * *		COPYRIGHT (C) 1996-2015 QLOGIC CORPORATION		**
  * *			ALL RIGHTS RESERVED				**
  * *									**
  * ***********************************************************************
@@ -59,18 +59,18 @@
  */
 static uint16_t ql_nvram_request(ql_adapter_state_t *, uint32_t);
 static int ql_nvram_24xx_config(ql_adapter_state_t *);
-static void ql_23_properties(ql_adapter_state_t *, nvram_t *);
-static void ql_24xx_properties(ql_adapter_state_t *, nvram_24xx_t *);
+static void ql_23_properties(ql_adapter_state_t *, ql_init_cb_t *);
+static void ql_24xx_properties(ql_adapter_state_t *, ql_init_24xx_cb_t *);
 static int ql_check_isp_firmware(ql_adapter_state_t *);
-static int ql_chip_diag(ql_adapter_state_t *);
 static int ql_load_flash_fw(ql_adapter_state_t *);
 static int ql_configure_loop(ql_adapter_state_t *);
 static int ql_configure_hba(ql_adapter_state_t *);
 static int ql_configure_fabric(ql_adapter_state_t *);
 static int ql_configure_device_d_id(ql_adapter_state_t *);
+static void ql_update_dev(ql_adapter_state_t *, uint32_t);
 static void ql_set_max_read_req(ql_adapter_state_t *);
 static void ql_configure_n_port_info(ql_adapter_state_t *);
-static void ql_clear_mcp(ql_adapter_state_t *);
+static void ql_reset_24xx_chip(ql_adapter_state_t *);
 static void ql_mps_reset(ql_adapter_state_t *);
 
 /*
@@ -95,7 +95,7 @@
 	la_els_logi_t		*els = &ha->loginparams;
 	int			retries = 5;
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_10(ha, "started cfg=0x%llx\n", ha->cfg_flags);
 
 	do {
 		/* Clear adapter flags. */
@@ -136,30 +136,17 @@
 			(void) ql_nvram_config(ha);
 		}
 
-		/* Set login parameters. */
-		if (CFG_IST(ha, CFG_CTRL_24258081)) {
-			els->common_service.rx_bufsize = CHAR_TO_SHORT(
-			    ha->init_ctrl_blk.cb24.max_frame_length[0],
-			    ha->init_ctrl_blk.cb24.max_frame_length[1]);
-			bcopy((void *)&ha->init_ctrl_blk.cb24.port_name[0],
-			    (void *)&els->nport_ww_name.raw_wwn[0], 8);
-			bcopy((void *)&ha->init_ctrl_blk.cb24.node_name[0],
-			    (void *)&els->node_ww_name.raw_wwn[0], 8);
-		} else {
-			els->common_service.rx_bufsize = CHAR_TO_SHORT(
-			    ha->init_ctrl_blk.cb.max_frame_length[0],
-			    ha->init_ctrl_blk.cb.max_frame_length[1]);
-			bcopy((void *)&ha->init_ctrl_blk.cb.port_name[0],
-			    (void *)&els->nport_ww_name.raw_wwn[0], 8);
-			bcopy((void *)&ha->init_ctrl_blk.cb.node_name[0],
-			    (void *)&els->node_ww_name.raw_wwn[0], 8);
-		}
-		bcopy(QL_VERSION, ha->adapter_stats->revlvl.qlddv,
-		    strlen(QL_VERSION));
-
 		/* Determine which RISC code to use. */
 		if ((rval = ql_check_isp_firmware(ha)) != QL_SUCCESS) {
-			if ((rval = ql_chip_diag(ha)) == QL_SUCCESS) {
+			if (ha->dev_state != NX_DEV_READY) {
+				EL(ha, "dev_state not ready, isp_abort_needed_2"
+				    "\n");
+				TASK_DAEMON_LOCK(ha);
+				ha->task_daemon_flags |= ISP_ABORT_NEEDED;
+				TASK_DAEMON_UNLOCK(ha);
+				break;
+			}
+			if ((rval = ql_mbx_wrap_test(ha, NULL)) == QL_SUCCESS) {
 				rval = ql_load_isp_firmware(ha);
 			}
 		}
@@ -167,19 +154,24 @@
 		if (rval == QL_SUCCESS && (rval = ql_set_cache_line(ha)) ==
 		    QL_SUCCESS && (rval = ql_init_rings(ha)) == QL_SUCCESS) {
 
+			ql_enable_intr(ha);
 			(void) ql_fw_ready(ha, ha->fwwait);
 
-			if (!(ha->task_daemon_flags & QL_SUSPENDED) &&
+			if (!DRIVER_SUSPENDED(ha) &&
 			    ha->loop_down_timer == LOOP_DOWN_TIMER_OFF) {
 				if (ha->topology & QL_LOOP_CONNECTION) {
 					ha->state = ha->state | FC_STATE_LOOP;
 					msg = "Loop ONLINE";
+					TASK_DAEMON_LOCK(ha);
 					ha->task_daemon_flags |= STATE_ONLINE;
+					TASK_DAEMON_UNLOCK(ha);
 				} else if (ha->topology & QL_P2P_CONNECTION) {
 					ha->state = ha->state |
 					    FC_STATE_ONLINE;
 					msg = "Link ONLINE";
+					TASK_DAEMON_LOCK(ha);
 					ha->task_daemon_flags |= STATE_ONLINE;
+					TASK_DAEMON_UNLOCK(ha);
 				} else {
 					msg = "Unknown Link state";
 				}
@@ -198,28 +190,37 @@
 
 	cmn_err(CE_NOTE, "!Qlogic %s(%d): %s", QL_NAME, ha->instance, msg);
 
-	/* Enable ISP interrupts and login parameters. */
-	if (CFG_IST(ha, CFG_CTRL_8021)) {
-		ql_8021_enable_intrs(ha);
-	} else if (CFG_IST(ha, CFG_CTRL_242581)) {
-		WRT32_IO_REG(ha, ictrl, ISP_EN_RISC);
-	} else {
-		WRT16_IO_REG(ha, ictrl, ISP_EN_INT + ISP_EN_RISC);
+	/* Enable ISP interrupts if not already enabled. */
+	if (!(ha->flags & INTERRUPTS_ENABLED)) {
+		ql_enable_intr(ha);
 	}
 
 	ADAPTER_STATE_LOCK(ha);
-	ha->flags |= (INTERRUPTS_ENABLED | ONLINE);
+	ha->flags |= ONLINE;
 	ADAPTER_STATE_UNLOCK(ha);
 
-	ha->task_daemon_flags &= ~(FC_STATE_CHANGE | RESET_MARKER_NEEDED |
+	/*
+	 * Set flash write-protection.
+	 */
+	if (CFG_IST(ha, CFG_ISP_FW_TYPE_2) &&
+	    ha->dev_state == NX_DEV_READY) {
+		ql_24xx_protect_flash(ha);
+	}
+
+	TASK_DAEMON_LOCK(ha);
+	ha->task_daemon_flags &= ~(FC_STATE_CHANGE | MARKER_NEEDED |
 	    COMMAND_WAIT_NEEDED);
+	TASK_DAEMON_UNLOCK(ha);
 
 	/*
 	 * Setup login parameters.
 	 */
+	bcopy(QL_VERSION, ha->adapter_stats->revlvl.qlddv, strlen(QL_VERSION));
+
 	els->common_service.fcph_version = 0x2006;
 	els->common_service.btob_credit = 3;
-	els->common_service.cmn_features = 0x8800;
+	els->common_service.cmn_features =
+	    ha->topology & QL_N_PORT ? 0x8000 : 0x8800;
 	els->common_service.conc_sequences = 0xff;
 	els->common_service.relative_offset = 3;
 	els->common_service.e_d_tov = 0x07d0;
@@ -228,12 +229,13 @@
 	class3_param->class_valid_svc_opt = 0x8800;
 	class3_param->rcv_data_size = els->common_service.rx_bufsize;
 	class3_param->conc_sequences = 0xff;
+	class3_param->open_sequences_per_exch = 1;
 
 	if (rval != QL_SUCCESS) {
 		EL(ha, "failed, rval = %xh\n", rval);
 	} else {
 		/*EMPTY*/
-		QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+		QL_PRINT_10(ha, "done\n");
 	}
 	return (rval);
 }
@@ -257,7 +259,7 @@
 	uint32_t	timer;
 	uint16_t	cmd, w16;
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_10(ha, "started\n");
 
 	if (CFG_IST(ha, CFG_SBUS_CARD)) {
 		w16 = (uint16_t)ddi_get16(ha->sbus_fpga_dev_handle,
@@ -273,8 +275,11 @@
 		 */
 		cmd = (uint16_t)ql_pci_config_get16(ha, PCI_CONF_COMM);
 		cmd = (uint16_t)(cmd | PCI_COMM_IO | PCI_COMM_MAE |
-		    PCI_COMM_ME | PCI_COMM_MEMWR_INVAL |
-		    PCI_COMM_PARITY_DETECT | PCI_COMM_SERR_ENABLE);
+		    PCI_COMM_ME | PCI_COMM_PARITY_DETECT |
+		    PCI_COMM_SERR_ENABLE);
+		if (ql_get_cap_ofst(ha, PCI_CAP_ID_PCIX)) {
+			cmd = (uint16_t)(cmd | PCI_COMM_MEMWR_INVAL);
+		}
 
 		/*
 		 * If this is a 2300 card and not 2312, reset the
@@ -328,7 +333,7 @@
 			}
 		}
 
-		if (!(CFG_IST(ha, CFG_CTRL_8021)) &&
+		if (!(CFG_IST(ha, CFG_CTRL_82XX)) &&
 		    ha->pci_max_read_req != 0) {
 			ql_set_max_read_req(ha);
 		}
@@ -342,12 +347,14 @@
 		ql_pci_config_put8(ha, PCI_CONF_LATENCY_TIMER, 0x40);
 
 		/* Reset expansion ROM address decode enable. */
-		w16 = (uint16_t)ql_pci_config_get16(ha, PCI_CONF_ROM);
-		w16 = (uint16_t)(w16 & ~BIT_0);
-		ql_pci_config_put16(ha, PCI_CONF_ROM, w16);
+		if (!CFG_IST(ha, CFG_CTRL_278083)) {
+			w16 = (uint16_t)ql_pci_config_get16(ha, PCI_CONF_ROM);
+			w16 = (uint16_t)(w16 & ~BIT_0);
+			ql_pci_config_put16(ha, PCI_CONF_ROM, w16);
+		}
 	}
 
-	QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_10(ha, "done\n");
 
 	return (QL_SUCCESS);
 }
@@ -370,11 +377,15 @@
 static void
 ql_set_max_read_req(ql_adapter_state_t *ha)
 {
+	int		ofst;
 	uint16_t	read_req, w16;
 	uint16_t	tmp = ha->pci_max_read_req;
 
-	if ((ha->device_id == 0x2422) ||
-	    ((ha->device_id & 0xff00) == 0x2300)) {
+	QL_PRINT_3(ha, "started\n");
+
+	if ((ofst = ql_get_cap_ofst(ha, PCI_CAP_ID_PCIX))) {
+		ofst += PCI_PCIX_COMMAND;
+		QL_PRINT_10(ha, "PCI-X Command Reg = %xh\n", ofst);
 		/* check for vaild override value */
 		if (tmp == 512 || tmp == 1024 || tmp == 2048 ||
 		    tmp == 4096) {
@@ -384,18 +395,18 @@
 			for (read_req = 0; tmp != 0; read_req++) {
 				tmp = (uint16_t)(tmp >> 1);
 			}
-			w16 = (uint16_t)ql_pci_config_get16(ha, 0x4e);
+			w16 = (uint16_t)ql_pci_config_get16(ha, ofst);
 			w16 = (uint16_t)(w16 & ~(BIT_3 & BIT_2));
 			w16 = (uint16_t)(w16 | (read_req << 2));
-			ql_pci_config_put16(ha, 0x4e, w16);
+			ql_pci_config_put16(ha, ofst, w16);
 		} else {
 			EL(ha, "invalid parameter value for "
 			    "'pci-max-read-request': %d; using system "
 			    "default\n", tmp);
 		}
-	} else if ((ha->device_id == 0x2432) || ((ha->device_id & 0xff00) ==
-	    0x2500) || (ha->device_id == 0x8432)) {
-		/* check for vaild override value */
+	} else if ((ofst = ql_get_cap_ofst(ha, PCI_CAP_ID_PCI_E))) {
+		ofst += PCI_PCIE_DEVICE_CONTROL;
+		QL_PRINT_10(ha, "PCI-E Device Control Reg = %xh\n", ofst);
 		if (tmp == 128 || tmp == 256 || tmp == 512 ||
 		    tmp == 1024 || tmp == 2048 || tmp == 4096) {
 			/* shift away the don't cares */
@@ -404,11 +415,11 @@
 			for (read_req = 0; tmp != 0; read_req++) {
 				tmp = (uint16_t)(tmp >> 1);
 			}
-			w16 = (uint16_t)ql_pci_config_get16(ha, 0x54);
+			w16 = (uint16_t)ql_pci_config_get16(ha, ofst);
 			w16 = (uint16_t)(w16 & ~(BIT_14 | BIT_13 |
 			    BIT_12));
 			w16 = (uint16_t)(w16 | (read_req << 12));
-			ql_pci_config_put16(ha, 0x54, w16);
+			ql_pci_config_put16(ha, ofst, w16);
 		} else {
 			EL(ha, "invalid parameter value for "
 			    "'pci-max-read-request': %d; using system "
@@ -415,6 +426,7 @@
 			    "default\n", tmp);
 		}
 	}
+	QL_PRINT_3(ha, "done\n");
 }
 
 /*
@@ -422,7 +434,7 @@
  *
  * Input:
  *	ha:		adapter state pointer.
- *	ha->hba_buf = request and response rings
+ *	ha->req_q[0]:	request ring
  *
  * Output:
  *	ha->init_ctrl_blk = initialization control block
@@ -441,17 +453,18 @@
 	caddr_t		dptr1, dptr2;
 	ql_init_cb_t	*icb = &ha->init_ctrl_blk.cb;
 	ql_ip_init_cb_t	*ip_icb = &ha->ip_init_ctrl_blk.cb;
-	nvram_t		*nv = (nvram_t *)ha->request_ring_bp;
-	uint16_t	*wptr = (uint16_t *)ha->request_ring_bp;
+	nvram_t		*nv = (nvram_t *)ha->req_q[0]->req_ring.bp;
+	uint16_t	*wptr = (uint16_t *)ha->req_q[0]->req_ring.bp;
 	uint8_t		chksum = 0;
 	int		rval;
 	int		idpromlen;
 	char		idprombuf[32];
 	uint32_t	start_addr;
+	la_els_logi_t	*els = &ha->loginparams;
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_10(ha, "started\n");
 
-	if (CFG_IST(ha, CFG_CTRL_24258081)) {
+	if (CFG_IST(ha, CFG_ISP_FW_TYPE_2)) {
 		return (ql_nvram_24xx_config(ha));
 	}
 
@@ -459,7 +472,7 @@
 	if ((rval = ql_lock_nvram(ha, &start_addr, LNF_NVRAM_DATA)) ==
 	    QL_SUCCESS) {
 		/* Verify valid NVRAM checksum. */
-		for (cnt = 0; cnt < sizeof (nvram_t)/2; cnt++) {
+		for (cnt = 0; cnt < sizeof (nvram_t) / 2; cnt++) {
 			*wptr = (uint16_t)ql_get_nvram_word(ha,
 			    (uint32_t)(cnt + start_addr));
 			chksum = (uint8_t)(chksum + (uint8_t)*wptr);
@@ -481,7 +494,7 @@
 		    ha->subven_id, nv->nvram_version);
 
 		/* Don't print nvram message if it's an on-board 2200 */
-		if (!((CFG_IST(ha, CFG_CTRL_2200)) &&
+		if (!((CFG_IST(ha, CFG_CTRL_22XX)) &&
 		    (ha->xioctl->fdesc.flash_size == 0))) {
 			cmn_err(CE_WARN, "%s(%d): NVRAM configuration failed,"
 			    " using driver defaults.", QL_NAME, ha->instance);
@@ -502,7 +515,7 @@
 		/*
 		 * Allow 2048 byte frames for 2300
 		 */
-		if (CFG_IST(ha, (CFG_CTRL_2300 | CFG_CTRL_6322))) {
+		if (CFG_IST(ha, CFG_CTRL_2363)) {
 			nv->max_frame_length[1] = 8;
 		}
 		nv->max_iocb_allocation[1] = 1;
@@ -516,8 +529,8 @@
 		    DDI_PROP_CANSLEEP, "idprom", (caddr_t)idprombuf,
 		    &idpromlen) != DDI_PROP_SUCCESS) {
 
-			QL_PRINT_3(CE_CONT, "(%d): Unable to read idprom "
-			    "property\n", ha->instance);
+			QL_PRINT_10(ha, "Unable to read idprom "
+			    "property\n");
 			cmn_err(CE_WARN, "%s(%d) : Unable to read idprom "
 			    "property", QL_NAME, ha->instance);
 
@@ -539,7 +552,7 @@
 		}
 
 		/* Don't print nvram message if it's an on-board 2200 */
-		if (!(CFG_IST(ha, CFG_CTRL_2200)) &&
+		if (!(CFG_IST(ha, CFG_CTRL_22XX)) &&
 		    (ha->xioctl->fdesc.flash_size == 0)) {
 			cmn_err(CE_WARN, "%s(%d): Unreliable HBA NVRAM, using"
 			    " default HBA parameters and temporary WWPN:"
@@ -553,7 +566,7 @@
 		nv->login_timeout = 4;
 
 		/* Set default connection options for the 23xx to 2 */
-		if (!(CFG_IST(ha, CFG_CTRL_2200))) {
+		if (!(CFG_IST(ha, CFG_CTRL_22XX))) {
 			nv->add_fw_opt[0] = (uint8_t)(nv->add_fw_opt[0] |
 			    BIT_5);
 		}
@@ -570,35 +583,10 @@
 		rval = QL_FUNCTION_FAILED;
 	}
 
-	/* Check for adapter node name (big endian). */
-	for (cnt = 0; cnt < 8; cnt++) {
-		if (nv->node_name[cnt] != 0) {
-			break;
-		}
-	}
-
-	/* Copy port name if no node name (big endian). */
-	if (cnt == 8) {
-		bcopy((void *)&nv->port_name[0], (void *)&nv->node_name[0], 8);
-		nv->node_name[0] = (uint8_t)(nv->node_name[0] & ~BIT_0);
-		nv->port_name[0] = (uint8_t)(nv->node_name[0] | BIT_0);
-	}
-
 	/* Reset initialization control blocks. */
 	bzero((void *)icb, sizeof (ql_init_cb_t));
+	bzero((void *)ip_icb, sizeof (ql_ip_init_cb_t));
 
-	/* Get driver properties. */
-	ql_23_properties(ha, nv);
-
-	cmn_err(CE_CONT, "!Qlogic %s(%d) WWPN=%02x%02x%02x%02x"
-	    "%02x%02x%02x%02x : WWNN=%02x%02x%02x%02x%02x%02x%02x%02x\n",
-	    QL_NAME, ha->instance, nv->port_name[0], nv->port_name[1],
-	    nv->port_name[2], nv->port_name[3], nv->port_name[4],
-	    nv->port_name[5], nv->port_name[6], nv->port_name[7],
-	    nv->node_name[0], nv->node_name[1], nv->node_name[2],
-	    nv->node_name[3], nv->node_name[4], nv->node_name[5],
-	    nv->node_name[6], nv->node_name[7]);
-
 	/*
 	 * Copy over NVRAM RISC parameter block
 	 * to initialization control block.
@@ -615,11 +603,63 @@
 	dptr1 = (caddr_t)&icb->add_fw_opt[0];
 	cnt = (uint32_t)((uintptr_t)&icb->reserved_3[0] -
 	    (uintptr_t)&icb->add_fw_opt[0]);
-
 	while (cnt-- != 0) {
 		*dptr1++ = *dptr2++;
 	}
 
+	ha->execution_throttle = CHAR_TO_SHORT(nv->execution_throttle[0],
+	    nv->execution_throttle[1]);
+	ha->loop_reset_delay = nv->reset_delay;
+	ha->port_down_retry_count = nv->port_down_retry_count;
+	ha->maximum_luns_per_target = CHAR_TO_SHORT(
+	    nv->maximum_luns_per_target[0], nv->maximum_luns_per_target[1]);
+	if (ha->maximum_luns_per_target == 0) {
+		ha->maximum_luns_per_target++;
+	}
+	ha->adapter_features = CHAR_TO_SHORT(nv->adapter_features[0],
+	    nv->adapter_features[1]);
+
+	/* Check for adapter node name (big endian). */
+	for (cnt = 0; cnt < 8; cnt++) {
+		if (icb->node_name[cnt] != 0) {
+			break;
+		}
+	}
+
+	/* Copy port name if no node name (big endian). */
+	if (cnt == 8) {
+		for (cnt = 0; cnt < 8; cnt++) {
+			icb->node_name[cnt] = icb->port_name[cnt];
+		}
+		icb->node_name[0] = (uint8_t)(icb->node_name[0] & ~BIT_0);
+		icb->port_name[0] = (uint8_t)(icb->node_name[0] | BIT_0);
+	}
+
+	ADAPTER_STATE_LOCK(ha);
+	ha->cfg_flags &= ~(CFG_ENABLE_FULL_LIP_LOGIN | CFG_ENABLE_TARGET_RESET |
+	    CFG_ENABLE_LIP_RESET | CFG_LOAD_FLASH_FW | CFG_FAST_TIMEOUT |
+	    CFG_DISABLE_RISC_CODE_LOAD | CFG_ENABLE_FWEXTTRACE |
+	    CFG_ENABLE_FWFCETRACE | CFG_SET_CACHE_LINE_SIZE_1 | CFG_LR_SUPPORT);
+	if (nv->host_p[0] & BIT_4) {
+		ha->cfg_flags |= CFG_DISABLE_RISC_CODE_LOAD;
+	}
+	if (nv->host_p[0] & BIT_5) {
+		ha->cfg_flags |= CFG_SET_CACHE_LINE_SIZE_1;
+	}
+	if (nv->host_p[1] & BIT_2) {
+		ha->cfg_flags |= CFG_ENABLE_FULL_LIP_LOGIN;
+	}
+	if (nv->host_p[1] & BIT_3) {
+		ha->cfg_flags |= CFG_ENABLE_TARGET_RESET;
+	}
+	nv->adapter_features[0] & BIT_3 ?
+	    (ha->flags |= MULTI_CHIP_ADAPTER) :
+	    (ha->flags &= ~MULTI_CHIP_ADAPTER);
+	ADAPTER_STATE_UNLOCK(ha);
+
+	/* Get driver properties. */
+	ql_23_properties(ha, icb);
+
 	/*
 	 * Setup driver firmware options.
 	 */
@@ -631,7 +671,7 @@
 	 * Always enable 64bit addressing, except SBUS cards.
 	 */
 	ha->cfg_flags |= CFG_ENABLE_64BIT_ADDRESSING;
-	if (CFG_IST(ha, (CFG_SBUS_CARD | CFG_CTRL_2300 | CFG_CTRL_6322))) {
+	if (CFG_IST(ha, CFG_SBUS_CARD | CFG_CTRL_2363)) {
 		icb->firmware_options[0] = (uint8_t)
 		    (icb->firmware_options[0] & ~BIT_3);
 		if (CFG_IST(ha, CFG_SBUS_CARD)) {
@@ -653,91 +693,83 @@
 	    (icb->firmware_options[0] & ~(BIT_5 | BIT_4));
 	icb->firmware_options[1] = (uint8_t)
 	    (icb->firmware_options[1] & ~BIT_4);
-
+	if (CFG_IST(ha, CFG_ENABLE_FCP_2_SUPPORT)) {
+		icb->firmware_options[1] = (uint8_t)
+		    (icb->firmware_options[1] | BIT_7 | BIT_6);
+		icb->add_fw_opt[1] = (uint8_t)
+		    (icb->add_fw_opt[1] | BIT_5 | BIT_4);
+	}
 	icb->add_fw_opt[1] = (uint8_t)(icb->add_fw_opt[1] & ~(BIT_5 | BIT_4));
 	icb->special_options[0] = (uint8_t)(icb->special_options[0] | BIT_1);
 
-	if (CFG_IST(ha, (CFG_CTRL_2300 | CFG_CTRL_6322))) {
+	if (CFG_IST(ha, CFG_CTRL_2363)) {
 		if ((icb->special_options[1] & 0x20) == 0) {
 			EL(ha, "50 ohm is not set\n");
 		}
 	}
-	icb->execution_throttle[0] = 0xff;
-	icb->execution_throttle[1] = 0xff;
 
-	if (CFG_IST(ha, CFG_ENABLE_FCP_2_SUPPORT)) {
-		icb->firmware_options[1] = (uint8_t)
-		    (icb->firmware_options[1] | BIT_7 | BIT_6);
-		icb->add_fw_opt[1] = (uint8_t)
-		    (icb->add_fw_opt[1] | BIT_5 | BIT_4);
-	}
-
 	/*
 	 * Set host adapter parameters
 	 */
-	ADAPTER_STATE_LOCK(ha);
-	ha->nvram_version = nv->nvram_version;
-	ha->adapter_features = CHAR_TO_SHORT(nv->adapter_features[0],
-	    nv->adapter_features[1]);
+	/* Get adapter id string for Sun branded 23xx only */
+	if (CFG_IST(ha, CFG_CTRL_23XX) && nv->adapInfo[0] != 0) {
+		(void) snprintf((int8_t *)ha->adapInfo, 16, "%s",
+		    nv->adapInfo);
+	}
 
-	nv->host_p[0] & BIT_4 ? (ha->cfg_flags |= CFG_DISABLE_RISC_CODE_LOAD) :
-	    (ha->cfg_flags &= ~CFG_DISABLE_RISC_CODE_LOAD);
-	nv->host_p[0] & BIT_5 ? (ha->cfg_flags |= CFG_SET_CACHE_LINE_SIZE_1) :
-	    (ha->cfg_flags &= ~CFG_SET_CACHE_LINE_SIZE_1);
-
-	nv->host_p[1] & BIT_1 ? (ha->cfg_flags |= CFG_ENABLE_LIP_RESET) :
-	    (ha->cfg_flags &= ~CFG_ENABLE_LIP_RESET);
-	nv->host_p[1] & BIT_2 ? (ha->cfg_flags |= CFG_ENABLE_FULL_LIP_LOGIN) :
-	    (ha->cfg_flags &= ~CFG_ENABLE_FULL_LIP_LOGIN);
-	nv->host_p[1] & BIT_3 ? (ha->cfg_flags |= CFG_ENABLE_TARGET_RESET) :
-	    (ha->cfg_flags &= ~CFG_ENABLE_TARGET_RESET);
-
-	nv->adapter_features[0] & BIT_3 ?
-	    (ha->cfg_flags |= CFG_MULTI_CHIP_ADAPTER) :
-	    (ha->cfg_flags &= ~CFG_MULTI_CHIP_ADAPTER);
-
-	ADAPTER_STATE_UNLOCK(ha);
-
-	ha->execution_throttle = CHAR_TO_SHORT(nv->execution_throttle[0],
-	    nv->execution_throttle[1]);
-	ha->loop_reset_delay = nv->reset_delay;
-	ha->port_down_retry_count = nv->port_down_retry_count;
 	ha->r_a_tov = (uint16_t)(icb->login_timeout < R_A_TOV_DEFAULT ?
 	    R_A_TOV_DEFAULT : icb->login_timeout);
-	ha->maximum_luns_per_target = CHAR_TO_SHORT(
-	    nv->maximum_luns_per_target[0], nv->maximum_luns_per_target[1]);
-	if (ha->maximum_luns_per_target == 0) {
-		ha->maximum_luns_per_target++;
-	}
 
+	els->common_service.rx_bufsize = CHAR_TO_SHORT(
+	    icb->max_frame_length[0], icb->max_frame_length[1]);
+	bcopy((void *)icb->port_name, (void *)els->nport_ww_name.raw_wwn, 8);
+	bcopy((void *)icb->node_name, (void *)els->node_ww_name.raw_wwn, 8);
+
+	cmn_err(CE_CONT, "!Qlogic %s(%d) WWPN=%02x%02x%02x%02x"
+	    "%02x%02x%02x%02x : WWNN=%02x%02x%02x%02x%02x%02x%02x%02x\n",
+	    QL_NAME, ha->instance,
+	    els->nport_ww_name.raw_wwn[0], els->nport_ww_name.raw_wwn[1],
+	    els->nport_ww_name.raw_wwn[2], els->nport_ww_name.raw_wwn[3],
+	    els->nport_ww_name.raw_wwn[4], els->nport_ww_name.raw_wwn[5],
+	    els->nport_ww_name.raw_wwn[6], els->nport_ww_name.raw_wwn[7],
+	    els->node_ww_name.raw_wwn[0], els->node_ww_name.raw_wwn[1],
+	    els->node_ww_name.raw_wwn[2], els->node_ww_name.raw_wwn[3],
+	    els->node_ww_name.raw_wwn[4], els->node_ww_name.raw_wwn[5],
+	    els->node_ww_name.raw_wwn[6], els->node_ww_name.raw_wwn[7]);
 	/*
 	 * Setup ring parameters in initialization control block
 	 */
-	cnt = REQUEST_ENTRY_CNT;
+	cnt = ha->req_q[0]->req_entry_cnt;
 	icb->request_q_length[0] = LSB(cnt);
 	icb->request_q_length[1] = MSB(cnt);
-	cnt = RESPONSE_ENTRY_CNT;
+	cnt = ha->rsp_queues[0]->rsp_entry_cnt;
 	icb->response_q_length[0] = LSB(cnt);
 	icb->response_q_length[1] = MSB(cnt);
 
-	icb->request_q_address[0] = LSB(LSW(LSD(ha->request_dvma)));
-	icb->request_q_address[1] = MSB(LSW(LSD(ha->request_dvma)));
-	icb->request_q_address[2] = LSB(MSW(LSD(ha->request_dvma)));
-	icb->request_q_address[3] = MSB(MSW(LSD(ha->request_dvma)));
-	icb->request_q_address[4] = LSB(LSW(MSD(ha->request_dvma)));
-	icb->request_q_address[5] = MSB(LSW(MSD(ha->request_dvma)));
-	icb->request_q_address[6] = LSB(MSW(MSD(ha->request_dvma)));
-	icb->request_q_address[7] = MSB(MSW(MSD(ha->request_dvma)));
+	start_addr = ha->req_q[0]->req_ring.cookie.dmac_address;
+	icb->request_q_address[0] = LSB(LSW(start_addr));
+	icb->request_q_address[1] = MSB(LSW(start_addr));
+	icb->request_q_address[2] = LSB(MSW(start_addr));
+	icb->request_q_address[3] = MSB(MSW(start_addr));
 
-	icb->response_q_address[0] = LSB(LSW(LSD(ha->response_dvma)));
-	icb->response_q_address[1] = MSB(LSW(LSD(ha->response_dvma)));
-	icb->response_q_address[2] = LSB(MSW(LSD(ha->response_dvma)));
-	icb->response_q_address[3] = MSB(MSW(LSD(ha->response_dvma)));
-	icb->response_q_address[4] = LSB(LSW(MSD(ha->response_dvma)));
-	icb->response_q_address[5] = MSB(LSW(MSD(ha->response_dvma)));
-	icb->response_q_address[6] = LSB(MSW(MSD(ha->response_dvma)));
-	icb->response_q_address[7] = MSB(MSW(MSD(ha->response_dvma)));
+	start_addr = ha->req_q[0]->req_ring.cookie.dmac_notused;
+	icb->request_q_address[4] = LSB(LSW(start_addr));
+	icb->request_q_address[5] = MSB(LSW(start_addr));
+	icb->request_q_address[6] = LSB(MSW(start_addr));
+	icb->request_q_address[7] = MSB(MSW(start_addr));
 
+	start_addr = ha->rsp_queues[0]->rsp_ring.cookie.dmac_address;
+	icb->response_q_address[0] = LSB(LSW(start_addr));
+	icb->response_q_address[1] = MSB(LSW(start_addr));
+	icb->response_q_address[2] = LSB(MSW(start_addr));
+	icb->response_q_address[3] = MSB(MSW(start_addr));
+
+	start_addr = ha->rsp_queues[0]->rsp_ring.cookie.dmac_notused;
+	icb->response_q_address[4] = LSB(LSW(start_addr));
+	icb->response_q_address[5] = MSB(LSW(start_addr));
+	icb->response_q_address[6] = LSB(MSW(start_addr));
+	icb->response_q_address[7] = MSB(MSW(start_addr));
+
 	/*
 	 * Setup IP initialization control block
 	 */
@@ -755,20 +787,23 @@
 	ip_icb->queue_size[0] = LSB(cnt);
 	ip_icb->queue_size[1] = MSB(cnt);
 
-	ip_icb->queue_address[0] = LSB(LSW(LSD(ha->rcvbuf_dvma)));
-	ip_icb->queue_address[1] = MSB(LSW(LSD(ha->rcvbuf_dvma)));
-	ip_icb->queue_address[2] = LSB(MSW(LSD(ha->rcvbuf_dvma)));
-	ip_icb->queue_address[3] = MSB(MSW(LSD(ha->rcvbuf_dvma)));
-	ip_icb->queue_address[4] = LSB(LSW(MSD(ha->rcvbuf_dvma)));
-	ip_icb->queue_address[5] = MSB(LSW(MSD(ha->rcvbuf_dvma)));
-	ip_icb->queue_address[6] = LSB(MSW(MSD(ha->rcvbuf_dvma)));
-	ip_icb->queue_address[7] = MSB(MSW(MSD(ha->rcvbuf_dvma)));
+	start_addr = ha->rcv_ring.cookie.dmac_address;
+	ip_icb->queue_address[0] = LSB(LSW(start_addr));
+	ip_icb->queue_address[1] = MSB(LSW(start_addr));
+	ip_icb->queue_address[2] = LSB(MSW(start_addr));
+	ip_icb->queue_address[3] = MSB(MSW(start_addr));
 
+	start_addr = ha->rcv_ring.cookie.dmac_notused;
+	ip_icb->queue_address[4] = LSB(LSW(start_addr));
+	ip_icb->queue_address[5] = MSB(LSW(start_addr));
+	ip_icb->queue_address[6] = LSB(MSW(start_addr));
+	ip_icb->queue_address[7] = MSB(MSW(start_addr));
+
 	if (rval != QL_SUCCESS) {
 		EL(ha, "failed, rval = %xh\n", rval);
 	} else {
 		/*EMPTY*/
-		QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+		QL_PRINT_10(ha, "done\n");
 	}
 	return (rval);
 }
@@ -794,7 +829,7 @@
 	uint32_t	nv_cmd;
 	uint16_t	rval;
 
-	QL_PRINT_4(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_4(ha, "started\n");
 
 	nv_cmd = address << 16;
 	nv_cmd = nv_cmd | NV_READ_OP;
@@ -801,7 +836,7 @@
 
 	rval = (uint16_t)ql_nvram_request(ha, nv_cmd);
 
-	QL_PRINT_4(CE_CONT, "(%d): NVRAM data = %xh\n", ha->instance, rval);
+	QL_PRINT_4(ha, "NVRAM data = %xh\n", rval);
 
 	return (rval);
 }
@@ -845,7 +880,7 @@
 	/* Read data from NVRAM. */
 
 	for (cnt = 0; cnt < 16; cnt++) {
-		WRT16_IO_REG(ha, nvram, NV_SELECT+NV_CLOCK);
+		WRT16_IO_REG(ha, nvram, NV_SELECT + NV_CLOCK);
 		ql_nv_delay();
 		data <<= 1;
 		reg_data = RD16_IO_REG(ha, nvram);
@@ -887,7 +922,7 @@
  *
  * Input:
  *	ha:		adapter state pointer.
- *	ha->hba_buf = request and response rings
+ *	ha->req_q[0]:	request ring
  *
  * Output:
  *	ha->init_ctrl_blk = initialization control block
@@ -902,7 +937,8 @@
 int
 ql_nvram_24xx_config(ql_adapter_state_t *ha)
 {
-	uint32_t		index, addr, chksum, saved_chksum;
+	uint32_t		index, addr;
+	uint32_t		chksum = 0, saved_chksum = 0;
 	uint32_t		*longptr;
 	nvram_24xx_t		nvram;
 	int			idpromlen;
@@ -914,8 +950,9 @@
 	ql_init_24xx_cb_t	*icb =
 	    (ql_init_24xx_cb_t *)&ha->init_ctrl_blk.cb24;
 	ql_ip_init_24xx_cb_t	*ip_icb = &ha->ip_init_ctrl_blk.cb24;
+	la_els_logi_t		*els = &ha->loginparams;
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_10(ha, "started\n");
 
 	if ((rval = ql_lock_nvram(ha, &addr, LNF_NVRAM_DATA)) == QL_SUCCESS) {
 
@@ -944,7 +981,6 @@
 
 		cmn_err(CE_WARN, "%s(%d): NVRAM configuration failed, using "
 		    "driver defaults.", QL_NAME, ha->instance);
-
 		EL(ha, "failed, rval=%xh, checksum=%xh, id=%c%c%c%c, "
 		    "nvram_version=%x\n", rval, chksum, nv->id[0], nv->id[1],
 		    nv->id[2], nv->id[3], CHAR_TO_SHORT(nv->nvram_version[0],
@@ -1021,7 +1057,7 @@
 		nv->port_down_retry_count[0] = 30;
 		nv->link_down_timeout[0] = 30;
 
-		if (CFG_IST(ha, CFG_CTRL_8081)) {
+		if (CFG_IST(ha, CFG_FCOE_SUPPORT)) {
 			nv->firmware_options_3[2] = BIT_4;
 			nv->feature_mask_l[0] = 9;
 			nv->ext_blk.version[0] = 1;
@@ -1038,35 +1074,9 @@
 		rval = QL_FUNCTION_FAILED;
 	}
 
-	/* Check for adapter node name (big endian). */
-	for (index = 0; index < 8; index++) {
-		if (nv->node_name[index] != 0) {
-			break;
-		}
-	}
-
-	/* Copy port name if no node name (big endian). */
-	if (index == 8) {
-		bcopy((void *)&nv->port_name[0], (void *)&nv->node_name[0], 8);
-		nv->node_name[0] = (uint8_t)(nv->node_name[0] & ~BIT_0);
-		nv->port_name[0] = (uint8_t)(nv->node_name[0] | BIT_0);
-	}
-
 	/* Reset initialization control blocks. */
 	bzero((void *)icb, sizeof (ql_init_24xx_cb_t));
 
-	/* Get driver properties. */
-	ql_24xx_properties(ha, nv);
-
-	cmn_err(CE_CONT, "!Qlogic %s(%d) WWPN=%02x%02x%02x%02x"
-	    "%02x%02x%02x%02x : WWNN=%02x%02x%02x%02x%02x%02x%02x%02x\n",
-	    QL_NAME, ha->instance, nv->port_name[0], nv->port_name[1],
-	    nv->port_name[2], nv->port_name[3], nv->port_name[4],
-	    nv->port_name[5], nv->port_name[6], nv->port_name[7],
-	    nv->node_name[0], nv->node_name[1], nv->node_name[2],
-	    nv->node_name[3], nv->node_name[4], nv->node_name[5],
-	    nv->node_name[6], nv->node_name[7]);
-
 	/*
 	 * Copy over NVRAM Firmware Initialization Control Block.
 	 */
@@ -1082,6 +1092,7 @@
 	icb->link_down_on_nos[0] = nv->link_down_on_nos[0];
 	icb->link_down_on_nos[1] = nv->link_down_on_nos[1];
 
+	/* Copy 2nd half. */
 	dst = (caddr_t)&icb->interrupt_delay_timer;
 	src = (caddr_t)&nv->interrupt_delay_timer;
 	index = (uint32_t)((uintptr_t)&icb->qos -
@@ -1090,10 +1101,16 @@
 		*dst++ = *src++;
 	}
 
-	/*
-	 * Setup driver firmware options.
-	 */
-	if (CFG_IST(ha, CFG_CTRL_8081)) {
+	ha->execution_throttle = 16;
+	ha->loop_reset_delay = nv->reset_delay;
+	ha->port_down_retry_count = CHAR_TO_SHORT(nv->port_down_retry_count[0],
+	    nv->port_down_retry_count[1]);
+	ha->maximum_luns_per_target = CHAR_TO_SHORT(
+	    nv->max_luns_per_target[0], nv->max_luns_per_target[1]);
+	if (ha->maximum_luns_per_target == 0) {
+		ha->maximum_luns_per_target++;
+	}
+	if (CFG_IST(ha, CFG_FCOE_SUPPORT)) {
 		dst = (caddr_t)icb->enode_mac_addr;
 		src = (caddr_t)nv->fw.isp8001.e_node_mac_addr;
 		index = sizeof (nv->fw.isp8001.e_node_mac_addr);
@@ -1110,7 +1127,45 @@
 		    icb->enode_mac_addr[0], icb->enode_mac_addr[1],
 		    icb->enode_mac_addr[2], icb->enode_mac_addr[3],
 		    icb->enode_mac_addr[4], icb->enode_mac_addr[5]);
-	} else {
+	}
+
+	/* Check for adapter node name (big endian). */
+	for (index = 0; index < 8; index++) {
+		if (icb->node_name[index] != 0) {
+			break;
+		}
+	}
+
+	/* Copy port name if no node name (big endian). */
+	if (index == 8) {
+		for (index = 0; index < 8; index++) {
+			icb->node_name[index] = icb->port_name[index];
+		}
+		icb->node_name[0] = (uint8_t)(icb->node_name[0] & ~BIT_0);
+		icb->port_name[0] = (uint8_t)(icb->node_name[0] | BIT_0);
+	}
+
+	ADAPTER_STATE_LOCK(ha);
+	ha->cfg_flags &= ~(CFG_ENABLE_FULL_LIP_LOGIN | CFG_ENABLE_TARGET_RESET |
+	    CFG_ENABLE_LIP_RESET | CFG_LOAD_FLASH_FW | CFG_FAST_TIMEOUT |
+	    CFG_DISABLE_RISC_CODE_LOAD | CFG_ENABLE_FWEXTTRACE |
+	    CFG_ENABLE_FWFCETRACE | CFG_SET_CACHE_LINE_SIZE_1 | CFG_LR_SUPPORT);
+	if (nv->host_p[1] & BIT_2) {
+		ha->cfg_flags |= CFG_ENABLE_FULL_LIP_LOGIN;
+	}
+	if (nv->host_p[1] & BIT_3) {
+		ha->cfg_flags |= CFG_ENABLE_TARGET_RESET;
+	}
+	ha->flags &= ~MULTI_CHIP_ADAPTER;
+	ADAPTER_STATE_UNLOCK(ha);
+
+	/* Get driver properties. */
+	ql_24xx_properties(ha, icb);
+
+	/*
+	 * Setup driver firmware options.
+	 */
+	if (!CFG_IST(ha, CFG_FCOE_SUPPORT)) {
 		icb->firmware_options_1[0] = (uint8_t)
 		    (icb->firmware_options_1[0] | BIT_1);
 		icb->firmware_options_1[1] = (uint8_t)
@@ -1131,31 +1186,16 @@
 		icb->firmware_options_2[1] = (uint8_t)
 		    (icb->firmware_options_2[1] & ~BIT_4);
 	}
-
 	icb->firmware_options_3[0] = (uint8_t)(icb->firmware_options_3[0] &
 	    ~BIT_7);
 
-	/* enable special N port 2 N port login behaviour */
-	if (CFG_IST(ha, CFG_CTRL_2425)) {
-		icb->firmware_options_3[1] =
-		    (uint8_t)(icb->firmware_options_3[1] | BIT_0);
-	}
-
-	icb->execution_throttle[0] = 0xff;
-	icb->execution_throttle[1] = 0xff;
-
 	/*
 	 * Set host adapter parameters
 	 */
+	w1 = CHAR_TO_SHORT(icb->login_timeout[0], icb->login_timeout[1]);
+	ha->r_a_tov = (uint16_t)(w1 < R_A_TOV_DEFAULT ? R_A_TOV_DEFAULT : w1);
+
 	ADAPTER_STATE_LOCK(ha);
-	ha->nvram_version = CHAR_TO_SHORT(nv->nvram_version[0],
-	    nv->nvram_version[1]);
-	nv->host_p[1] & BIT_2 ? (ha->cfg_flags |= CFG_ENABLE_FULL_LIP_LOGIN) :
-	    (ha->cfg_flags &= ~CFG_ENABLE_FULL_LIP_LOGIN);
-	nv->host_p[1] & BIT_3 ? (ha->cfg_flags |= CFG_ENABLE_TARGET_RESET) :
-	    (ha->cfg_flags &= ~CFG_ENABLE_TARGET_RESET);
-	ha->cfg_flags &= ~(CFG_DISABLE_RISC_CODE_LOAD | CFG_LR_SUPPORT |
-	    CFG_SET_CACHE_LINE_SIZE_1 | CFG_MULTI_CHIP_ADAPTER);
 	ha->cfg_flags |= CFG_ENABLE_64BIT_ADDRESSING;
 	if (CFG_IST(ha, CFG_CTRL_81XX) && nv->enhanced_features[0] & BIT_0) {
 		ha->cfg_flags |= CFG_LR_SUPPORT;
